function [Z0,epseff, lambda4] = ms_susp2_impedance(w,a, epsr, b)
% Function taken from webpage view-source: http://www17.plala.or.jp/i-lab/tool/sus_ms_e.htm source
%
%      w 
% +++----+++
%           a  epsr substrate 
% ++++++++++
%           b  air
% ------------ gnd 
%    

e0 = epsr;
a0 = a; % in mm
b0 = b; % in mm
f0 = 1e3;   % in MHz
w0 = w; % in mm

u  = w0./(a0+b0);
k1 = (30.666./u).^0.7528;
k2 = exp(-k1);
fu = 6+(2*pi-6)*k2;
k3 = a0./b0;
k4 = log(k3);
k5 = 0.8621-0.1251*k4;
k6 = 0.4986-0.1397*k4;
a1 = k5.^4;
b1 = k6.^4;
k7 = sqrt(e0);
k8 = k3.*(a1-b1.*log(w0./b0)).*(1./k7-1);
ef2= 1./(1+k8);
ef = ef2.*ef2;

k9 = sqrt(1+4./(u.*u));
k10= log(fu./u+k9);

zz = 60.*k10./ef2;

Z0 = zz;
epseff = ef;
k = 1/ef2;
lambda4 = 30.*1e10.*k./(f0.*1e6.*4); % quarter wavelength

end
